1 # Ocean Interpreter test code
3 Regular testing is, of course, important for developing any software.
4 The Ocean interpreted is no exception. This document allows easy
7 - a collection of test program
8 - the expected output of these programs when run with various arguments
9 - some "Makefile" code to tie it all together.
11 Three different sorts of tests are run. As soon as any fail, the whole
14 1/ Each program is run and the output is compared against the expected
16 2/ Each program is then run under valgrind, and an error is reported
17 if valgrind detects an error, or if it reports and lost or unfreed
19 3/ Each program is parsed and printed, then the result is parsed and printed.
20 The two results must match.
21 4/ Each program is run with a version of `oceani` with test-coverage
22 recording enabled. Once all programs have successfully run and
23 all the coverage data is available, we check that all lines have
24 been tested at least once. A few exceptions are allowed such as
25 lines that call `abort()`. If any non-exceptional lines have not
26 been run, this final test fails.
27 Until the tests suite is (more) completed, we only throw and error
28 if fewer than 75% of the lines have been tested.
30 Each test has a name, which used to identify the section in this file, and optionally some
31 arguments separated from the name by commas. For each test, there is a section named
32 "output:" followed by the name-and-arguments.
34 ###### File: oceani-tests.mk
38 oceani_valg_tests := $(oceani_tests)
41 tests:: oceani_test_suite
42 oceani_test_suite: oceani coverage_oceani
43 @echo -n Checking grammar ...
44 @./parsergen --report --LALR --tag Parser oceani.mdc | grep " - no conflicts" > /dev/null || \
45 { echo "Grammar contains conflicts, please review" ; exit 1; }
47 @rm -rf coverage; mkdir -p coverage
49 @for T in $(oceani_tests); do \
50 echo -n "Test $$T.. "; \
51 i="$$IFS"; IFS=,; set $$T; IFS="$$i"; t=$$1; shift; \
52 ./md2c oceani-tests.mdc "output: $$T" | grep -v '^#' > .tmp.want; \
53 ./oceani --section "test: $$t" oceani-tests.mdc $${1+"$$@"} > .tmp.have; \
54 if ! cmp -s .tmp.want .tmp.have; then \
55 echo "FAILED"; diff -u .tmp.want .tmp.have ; exit 1; fi ;\
56 echo -n "printing.. "; \
57 echo '``````' > .tmp.code1; echo '``````' > .tmp.code2 ;\
58 ./oceani --noexec --print --section "test: $$t" oceani-tests.mdc >> .tmp.code1; \
59 ./oceani --noexec --print .tmp.code1 >> .tmp.code2 || exit 1;\
60 if ! cmp -s .tmp.code1 .tmp.code2; then \
61 echo " Failed"; diff -u .tmp.code1 .tmp.code2; exit 1 ; fi ; \
62 echo -n "extra-newlines.. "; \
64 ' .tmp.code1 > .tmp.code1a; \
65 echo '``````' > .tmp.code2a ;\
66 ./oceani --noexec --print .tmp.code1a >> .tmp.code2a || exit 1;\
67 if ! cmp -s .tmp.code1 .tmp.code2a; then \
68 echo " Failed"; diff -u .tmp.code1 .tmp.code2a; exit 1; fi ; \
69 echo -n "exec-after-print.. "; \
70 ./oceani .tmp.code1 $${1+"$$@"} > .tmp.have ; \
71 if ! cmp -s .tmp.want .tmp.have; then \
72 echo " FAILED"; diff -u .tmp.want .tmp.have; exit 1;fi; \
74 ./coverage_oceani --print --section "test: $$t" oceani-tests.mdc $${1+"$$@"} > /dev/null ; \
75 ./coverage_oceani -tpbn --section "test: $$t" oceani-tests.mdc > /dev/null 2>&1; \
80 @for i in coverage/#*.gcda; do mv $$i coverage/$${i##*#}; done
81 @gcov -o coverage oceani.mdc > /dev/null 2> /dev/null
82 @mv *.gcov coverage ; [ -f .gcov ] && mv .gcov coverage || true
85 @[ -n "$$SKIP_VALGRIND" ] || for T in $(oceani_valg_tests); do \
86 echo -n "Valgrind $$T.. "; \
87 i="$$IFS"; IFS=,; set $$T; IFS="$$i"; t=$$1; shift; \
88 if valgrind --error-exitcode=42 --log-file=.tmp.valg ./oceani --section "test: $$t" oceani-tests.mdc $${1+"$$@"} \
89 > /dev/null 2>&1 ; [ $$? -eq 42 ] ; then \
90 echo "FAILED"; cat .tmp.valg; exit 1; fi ; \
91 if grep 'LEAK SUMMARY' .tmp.valg > /dev/null; then \
92 echo "valgrind found LEAKS"; cat .tmp.valg ; exit 1 ; fi; \
93 if grep 'in use at exit [1-9]' .tmp.valg > /dev/null; then \
94 echo "valgrind found memory in use at exit"; cat .tmp.valg ; exit 1 ; fi; \
98 @[ -n "$$SKIP_COVERAGE_CHECK" ] || awk '/NOTEST/ { next } /^ *[1-9]/ {ran+=1} /^ *###/ {skip+=1} \
99 END {printf "coverage: %6.2f%%\n", ran * 100 / (ran + skip); \
100 if (ran < (ran + skip) *0.968) exit(1) }' \
101 coverage/oceani.mdc.gcov
103 coverage_oceani: oceani.c
104 $(CC) $(CFLAGS) --coverage -fprofile-dir=coverage -o coverage_oceani oceani.c $(LDLIBS)
106 ## Values and variables
108 The first test stores values in variables and performs various
109 calculations on them.
112 oceani_tests += "valvar"
116 func main(argv:[argc::]string)
117 a := 23; b:=12 ; b1 := -b
118 print a, b, a+b, a-b, a*b, a/b, a%b
119 print a<b, a<=b, a>b, a>=b, a<a, a==b, a==a
120 print +a, +b, +b1, -a, -b, -b1
121 x := True; y := False
122 print x and y, x or y, x and x, y or y, x and not x, x < y
124 c ::= "This is a string"
125 d ::= " field theory"
128 aconst :: string = "unchanging"
137 ###### output: valvar
139 23 12 35 11 276 1.91667 11
140 False False True True False False True
142 False True True False False False
143 This is a string field theory This is a string field theory
146 Next we change the value of variables
149 oceani_tests += "setvar"
156 a = (a + a) * (a + a)
160 ###### output: setvar
166 oceani_tests += "consts"
171 four ::= 2 + 2 ; five ::= 10/2
172 const pie ::= "I like Pie";
173 cake ::= "The cake is"
177 print "Hello World, what lovely oceans you have!"
178 print "are there", five, "?"
179 print pi, pie, "but", cake
181 ###### output: consts
182 Hello World, what lovely oceans you have!
184 3.14159 I like Pie but The cake is a lie
186 Test merging of variables from multiple cases
189 oceani_tests += varmerge
191 ###### test: varmerge
194 for i:=0; then i=i+1; while i < 5:
197 case 1: scratch:=42; num:="one"
204 for i:=0; then i=i+1; while i < 5:
211 // re-declare a CondScope variable
216 ###### output: varmerge
217 zero , one , two , three , many ,
220 ## Conditions and Loops
222 Now we need to test if/else and some different loops
225 oceani_tests += cond_loop
227 ###### test: cond_loop
235 for b:=1; then b=b+b; while b < 100:
238 // Newtons method for square root of 2
244 current := guess * guess
245 use +(current - target) > 0.000000001
247 guess = (guess + (target / guess) ) / 2
250 print "error is ", target - guess * guess
252 for j:=0; then j = j+3 ; while j < 10:
253 if j != 0 and then 20 / j > 3:
254 print "20 /", j," =", 20 / j
256 print "I won't calculate 20 /", j
257 pi ::= 3.1415926535897
258 if 355/113 == pi or else +(pi - 355/113) < 0.001:
260 print "lower" if 355/113 < pi else "higher"
262 if pi > 3 then print "pi exceeds three"; else print "need more pie"
263 if (pi < 3) { print "not enough pi" } else { print "pi sufficient" }
264 for { i := 0; sum := 0 }
270 print "sum 1..10 is", sum
279 ###### output: cond_loop
286 error is -4.51095e-12
287 I won't calculate 20 / 0
290 I won't calculate 20 / 9
300 The demonstration code presented in the interpreted is suitable for the test suite.
301 Here I break it into two parts, keeping the array code separate.
304 oceani_tests += "sayhello,55,33,hello,True"
305 oceani_tests += "sayhello,12,60,there,False"
307 ###### test: sayhello
309 func main(av:[ac::number]string)
310 A := $av[1]; B := $av[2]
312 bbool := av[ac-1] == "True"
313 print "Hello World, what lovely oceans you have!"
314 /* When a variable is defined in both branches of an 'if',
315 * and used afterwards, the variables are merged.
321 print "Is", A, "bigger than", B,"? ", bigger
322 /* If a variable is not used after the 'if', no
323 * merge happens, so types can be different
326 double:string = "yes"
327 print A, "is more than twice", B, "?", double
330 print "double", B, "is", double
335 print "still", bigger // check for regression in scoping
342 print "GCD of", A, "and", B,"is", a
344 print a, "is not positive, cannot calculate GCD"
346 print b, "is not positive, cannot calculate GCD"
351 print "Fibonacci:", f1,f2,
361 print astr ++ " was the str"
363 print "I found the str over " ++ astr
365 /* Binary search... */
383 print "Yay, I found", target
385 print "Closest I found was", lo
387 ###### output: sayhello,55,33,hello,True
388 Hello World, what lovely oceans you have!
389 Is 55 bigger than 33 ? yes
392 GCD of 55 and 33 is 11
393 Fibonacci: 1 1 2 3 5 8 13 21 34 55 89 144
395 Closest I found was 77.3438
397 ###### output: sayhello,12,60,there,False
398 Hello World, what lovely oceans you have!
399 Is 12 bigger than 60 ? no
402 GCD of 12 and 60 is 12
403 Fibonacci: 1 1 2 3 5 8 13 21 34 55 89 144
404 I found the str over there
405 Closest I found was 77.3438
408 oceani_tests += "insert_sort"
409 ###### test: insert_sort
414 for i:=1; then i = i + 1; while i < size:
415 n := list[i-1] * list[i-1]
416 list[i] = (n / 100) % 10000
419 for i:=0; then i = i + 1; while i < size:
420 print "list[",i,"]=",list[i]
422 for i := 1; then i=i+1; while i < size:
423 for j:=i-1; then j=j-1; while j >= 0:
424 if list[j] > list[j+1]:
429 for i:=0; then i = i + 1; while i < size:
430 print "list[",i,"]=",list[i]
432 ###### output: insert_sort
548 We already have some array tests, but this is where we put other
549 ad-hoc things array related.
552 oceani_tests += arrays
560 bools[3] = strings[1] == "Hello"
561 bools[1] = strings[2] <= "there"
563 for i:=0; then i=i+1; while i<5:
567 ra[6] = 42 // mustn't crash
568 print '', bools[i], ra[j-1],
571 ###### output: arrays
572 False 0 True 1 False 4 False 9 False 16
576 Time to test if structure declarations and accesses work correctly.
579 oceani_tests += structs
587 active:Boolean = True
589 struct baz { a:number; b:Boolean; }
595 for i:=0; then i=i+1; while i < 4:
603 info[i].size[0] = i*i
605 info[i].active = False
607 for i:=0; then i=i+1; while i < 4:
608 print info[i].name, info[i].active, info[i].size[0]
610 ###### output: structs
619 Test functions. They don't return anything, so we need to get them to print
622 oceani_tests += functions func_ret_type
624 ###### test: functions
644 func test(n:number; s:string)
651 for i:=0; then i = i + 1; while i < 5:
654 ###### output: functions
659 4 3 . 2 .. 1 ... done
661 ###### test: func_ret_type
663 func double(n:number):number
679 for j:=10; then j = j - 3; while j > -5:
680 print answer("dou","ble"), j, "is", double(j)
682 ###### output: func_ret_type
689 ## Test code with syntax errors
691 Syntax errors aren't handled well yet - the result is almost always a
692 single message about the first error. So this section will be fairly
693 thin until we add proper parsing recovery in the face of common errors.
695 A special case of syntax errors is token errors, when a token is only
696 accepted because the parser doesn't know quite enough to reject it.
697 There are handled better as they are quite local, so a single test
698 program can trigger most of the possible errors.
700 To handle erronous code, we need a different set of tests, as we need to
701 capture `stderr`. The same test code will be used for type errors too.
702 As error messages contain the line number, and we don't want changes to
703 this file to change the reported numbers, we copy the code into a
704 separate file first, then run from there.
707 @for t in $(oceani_failing_tests); do \
708 echo -n "Test $$t ... "; \
709 ./md2c oceani-tests.mdc "output: $$t" | grep -v '^#' > .tmp.want; \
710 echo '``````' > .tmp.code; \
711 ./md2c oceani-tests.mdc "test: $$t" | grep -v '^#' >> .tmp.code; \
712 ./oceani .tmp.code > .tmp.have 2>&1; \
713 if ! cmp -s .tmp.want .tmp.have; then \
714 echo "FAILED"; diff -u .tmp.want .tmp.have ; exit 1; fi ;\
716 ./coverage_oceani --section "test: $$t" oceani-tests.mdc > /dev/null 2>&1 ;\
719 ###### combine test lists
720 oceani_valg_tests += $(oceani_failing_tests)
723 oceani_failing_tests := syn1
724 oceani_failing_tests += tokerr
729 if then else while do
732 .tmp.code:3:11: Syntax error in statement: then
736 a := 1i // imaginary numbers aren't understood
737 b:[2i]number // array sizes are handled separately
738 c:[3.14159]Boolean // array sizes must be integers
739 d:[1_000_000_000_000]number // they mustn't be huge
740 patn: string = "foo[ ,_]*bar"re // regexp strings are just a dream
743 This is a multiline string
744 With an unsupportable suffix
748 yy:[unknowable]number
750 zz:[zzsize]string // size must be constant, use ::=
752 // These numbers should be bad in all contexts: FIXME
755 ###### output: tokerr
756 .tmp.code:3:13: error: unsupported number suffix: 1i
757 .tmp.code:4:11: error: unsupported number suffix: 2i
758 .tmp.code:5:11: error: array size must be an integer: 3.14159
759 .tmp.code:6:11: error: array size is too large: 1_000_000_000_000
760 .tmp.code:7:23: error: unsupported string suffix: "foo[ ,_]*bar"re
761 .tmp.code:9:17: error: unsupported string suffix: """
762 This is a multiline string
763 With an unsupportable suffix
765 .tmp.code:14:11: error: undefined type: unknown
766 .tmp.code:15:12: error: name undeclared: unknowable
767 .tmp.code:17:12: error: array size must be a constant: zzsize
768 .tmp.code:20:12: error: unrecognised number: 00123
770 ## Tests for type errors
772 Type error don't cause parsing to abort, so we can fit many in the
773 one test program. Some type errors are found during the parse, others
774 during type analysis which doesn't run if parsing failed. So we cannot
775 fit everything in one.
777 These programs were generated by looking for the
778 various places that `type_err()` are called.
781 oceani_failing_tests += type_err1 type_err2 type_err3 type_err4
783 ###### test: type_err1
786 print "hello" ++ 5, 5 ++ "hello"
791 if 3 * 4 and not True: print "Weird"
793 ###### output: type_err1
794 .tmp.code:3:25: error: expected string found number
795 .tmp.code:3:28: error: expected string found number
796 .tmp.code:6:8: error: Cannot assign to a constant: b
797 .tmp.code:5:8: info: name was defined as a constant here
798 .tmp.code:6:8: error: Cannot assign to a constant: b
799 .tmp.code:5:8: info: name was defined as a constant here
800 .tmp.code:8:11: error: Arithmetic returns number but Boolean expected
801 oceani: type error in program - not running.
803 ###### test: type_err2
813 ###### output: type_err2
814 .tmp.code:4:8: error: variable 'a' redeclared
815 .tmp.code:3:8: info: this is where 'a' was first declared
816 .tmp.code:5:8: error: variable 'a' redeclared
817 .tmp.code:3:8: info: this is where 'a' was first declared
818 .tmp.code:6:8: error: variable 'a' redeclared
819 .tmp.code:3:8: info: this is where 'a' was first declared
820 .tmp.code:7:8: error: variable 'a' redeclared
821 .tmp.code:3:8: info: this is where 'a' was first declared
822 .tmp.code:8:8: Variable declared with no type or value: c
824 ###### test: type_err3
833 c = "hello" ++ (True and False)
835 print 45 + ( "Hello" ++ "there")
845 case "Hello": print "Hello"
847 a1:[5]number; a2:[5]number; a3:[10]number; a4:[5]string
861 // trigger 'labels not permitted' error message
862 while 1 if True else False:
866 ###### output: type_err3
867 .tmp.code:8:12: error: expected number but variable 'c' is string
868 .tmp.code:7:8: info: this is where 'c' was set to string
869 .tmp.code:8:12: error: Arithmetic returns number but string expected
870 .tmp.code:7:8: info: variable 'c' was set as string here.
871 .tmp.code:9:24: error: Boolean operation found where string expected
872 .tmp.code:10:12: error: Comparison returns Boolean but string expected
873 .tmp.code:7:8: info: variable 'c' was set as string here.
874 .tmp.code:11:21: error: Concat returns string but number expected
875 .tmp.code:12:8: error: string cannot be indexed
876 .tmp.code:12:8: error: string cannot be indexed
877 .tmp.code:21:13: error: expected number found string
878 .tmp.code:17:16: error: expected number, found string
879 .tmp.code:24:8: error: cannot assign value of type [5]number
880 .tmp.code:25:13: error: expected [5]number but variable 'a3' is [10]number
881 .tmp.code:23:36: info: this is where 'a3' was set to [10]number
882 .tmp.code:25:8: error: cannot assign value of type [5]number
883 .tmp.code:26:13: error: expected [5]number but variable 'a4' is [5]string
884 .tmp.code:23:51: info: this is where 'a4' was set to [5]string
885 .tmp.code:26:8: error: cannot assign value of type [5]number
886 .tmp.code:27:16: error: expected number found string
887 .tmp.code:28:16: error: expected string found Boolean
888 .tmp.code:29:12: error: have number but need string
889 .tmp.code:7:8: info: variable 'c' was set as string here.
890 .tmp.code:32:8: error: variable used but not declared: foo
891 .tmp.code:32:8: error: field reference attempted on none, not a struct
892 .tmp.code:32:16: error: expected none found number
893 .tmp.code:33:14: error: field reference attempted on string, not a struct
894 .tmp.code:34:14: error: cannot find requested field in foo
895 .tmp.code:35:17: error: have string but need number
896 .tmp.code:38:29: error: expected number (labels not permitted) found Boolean
897 oceani: type error in program - not running.
899 ###### test: type_err4
904 ###### output: type_err4
905 .tmp.code:3:14: error: variable used but not declared: b
906 .tmp.code:3:16: error: expected none found number
907 .tmp.code:3:14: info: variable 'b' was set as none here.
908 oceani: type error in program - not running.
911 oceani_failing_tests += type_err_const type_err_const1 missing_program bad_main
913 ###### test: type_err_const
916 bar ::= "string" + 56
923 // trigger duplicate-main error
928 ###### output: type_err_const
929 .tmp.code:4:16: error: expected number found string
930 .tmp.code:6:8: error: name already declared: bar
931 .tmp.code:4:8: info: this is where 'bar' was first declared
932 .tmp.code:8:8: error: variable 'foo' redeclared
933 .tmp.code:3:8: info: this is where 'foo' was first declared
934 .tmp.code:12:5: error: function 'main' redeclared
935 .tmp.code:7:5: info: this is where 'main' was first declared
936 .tmp.code:13:8: error: variable 'foo' redeclared
937 .tmp.code:3:8: info: this is where 'foo' was first declared
939 ###### test: type_err_const1
947 ###### output: type_err_const1
948 .tmp.code:3:12: Syntax error in constant: :
949 .tmp.code:4:12: Syntax error in constant: :
951 ###### test: missing_program
955 ###### output: missing_program
956 oceani: no main function found.
958 ###### test: bad_main
959 func main(foo:string)
962 ###### output: bad_main
963 .tmp.code:??:??: error: expected argv but variable 'foo' is string
964 .tmp.code:??:??: info: this is where 'NOTVAR' was set to string
965 oceani: main has wrong type.
967 Test for type errors with functions
970 oceani_failing_tests += func_err_args func_err_redeclare
972 ###### test: func_err_args
974 func test1(a:number; b:string; c:[3]Boolean)
977 func test2(a:number; b:string; c:[3]Boolean)
981 # use undefined names
989 test1(1, "two", truth)
991 test1(1, "lo", truth, 4)
992 print test(), test1(1,2,3)
996 func test4(a:number):string
999 func test5(a:number):string
1002 ###### output: func_err_args
1003 .tmp.code:28:14: error: expected string, found none
1004 .tmp.code:25:8: error: expected string, found number
1005 .tmp.code:15:14: error: insufficient arguments to function.
1006 .tmp.code:16:14: error: expected number found string
1007 .tmp.code:16:22: error: expected string found number
1008 .tmp.code:16:14: error: insufficient arguments to function.
1009 .tmp.code:18:17: error: expected string found number
1010 .tmp.code:19:14: error: too many arguments to function.
1011 .tmp.code:20:14: error: attempt to call a non-function.
1012 .tmp.code:20:32: error: expected string found number
1013 .tmp.code:20:28: error: insufficient arguments to function.
1014 .tmp.code:21:20: error: expected func but variable 'test2' is func
1015 .tmp.code:??:??: info: this is where 'NOTVAR' was set to func
1016 .tmp.code:10:14: error: variable used but not declared: a
1017 .tmp.code:10:17: error: variable used but not declared: z
1018 oceani: type error in program - not running.
1020 ###### test: func_err_redeclare
1022 func test1(a:number; b:string; c:[3]Boolean)
1034 ###### output: func_err_redeclare
1035 .tmp.code:5:5: error: function 'test1' redeclared
1036 .tmp.code:2:5: info: this is where 'test1' was first declared
1037 .tmp.code:9:5: error: function 'test1' redeclared
1038 .tmp.code:2:5: info: this is where 'test1' was first declared
1040 ## Test erroneous command line args
1042 To improve coverage, we want to test correct handling of strange command
1043 line arguments. These tests won't use code, so the exiting test types
1044 won't work. So we need to be able to explicitly give the command line,
1045 and the expected output, and have that tested and the coverage assessed.
1046 Rather than having to spell out the whole command name, just give "cmd",
1047 and discard that. Requiring but discarding the command make an empty
1048 command list possible.
1051 @for t in $(oceani_special_tests); do \
1052 echo -n "Test $$t ... ";\
1053 i="$$IFS"; IFS=,; set $$t; IFS="$$i"; shift ;\
1054 ./md2c oceani-tests.mdc "output: $$t" | grep -v '^#' > .tmp.want; \
1055 ./oceani $${1+"$$@"} > .tmp.have 2>&1 ;\
1056 if ! cmp -s .tmp.want .tmp.have; then \
1057 echo "FAILED"; diff -u .tmp.want .tmp.have ; exit 1; fi ;\
1059 ./coverage_oceani $${1+"$$@"} > /dev/null 2>&1 ;\
1061 ###### valgrind test code
1062 @[ -n "$$SKIP_VALGRIND" ] || for t in $(oceani_special_tests); do\
1063 echo -n "Valgrind $$t.. "; \
1064 i="$$IFS"; IFS=,; set $$t; IFS="$$i"; shift ;\
1065 if valgrind --error-exitcode=42 --log-file=.tmp.valg ./oceani $${1+"$$@"} > .tmp.have 2>&1 ;\
1066 [ $$? -eq 42 ]; then \
1067 echo "FAILED"; cat .tmp.valg; exit 1; fi ; \
1068 if grep 'LEAK SUMMARY' .tmp.valg > /dev/null; then \
1069 echo "valgrind found LEAKS"; cat .tmp.valg ; exit 1 ; fi; \
1070 if grep 'in use at exit [1-9]' .tmp.valg > /dev/null; then \
1071 echo "valgrind found memory in use at exit"; cat .tmp.valg ; exit 1 ; fi; \
1076 oceani_special_tests += "cmd"
1077 oceani_special_tests += "cmd,-zyx"
1078 oceani_special_tests += "cmd,nofile"
1079 oceani_special_tests += "cmd,/dev/null"
1080 oceani_special_tests += "cmd,--section,toast:nothing,oceani-tests.mdc"
1083 oceani: no input file given
1085 ###### output: cmd,-zyx
1086 ./oceani: invalid option -- 'z'
1087 Usage: oceani --trace --print --noexec --brackets --section=SectionName prog.ocn
1089 ###### output: cmd,nofile
1090 oceani: cannot open nofile
1092 ###### output: cmd,/dev/null
1093 oceani: could not find any code in /dev/null
1095 ###### output: cmd,--section,toast:nothing,oceani-tests.mdc
1096 oceani: cannot find section toast:nothing